/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1822
        Driver Version    :  2.00

  Peripherals: 
    G-Sensor : MMA8452Q
    IR-LED : SLR-938CV-A 
    IR-Receiver : OSRB38C9AA

*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "i2c-lib.h"

#define MMA8452_ADRS 0x3A       // ZT[X[uAhX`:0x1D(0011101)+0 -> 3A 

// O[oϐ錾
unsigned int X,Y,Z;            // 12 bit Glf[^i[ϐ(X:X,Y:Y,Z:Z)
unsigned int data[5];          // ZT[Mf[^i[p
unsigned int YF = 3600;        // Oi臒l
unsigned int YB = 500;         // i臒l
unsigned int XR = 500;         // E臒l
unsigned int XL = 3600;        // 臒l

// vg^CsO錾
void MMA8452_init(void);        // ZT[ݒ 
void MMA8452(void);             // Gf[^擾֐
void b1(void);                  // o[XgM(38kHz/600us)֐
void b0(void);                  // uN(600us)֐

/*
     Main application
 */

void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // foCX    
    MMA8452_init();             // ZT[ݒ    
    
    while (1)
    {
        // Add your application code
        
        MMA8452();             // Gf[^擾֐Ăяo 

        // 12 bitf[^    
        X = (data[0] << 8 | data[1]) >> 4;       // X 8 bit+4bit  
        Y = (data[2] << 8 | data[3]) >> 4;       // Y 8 bit+4bit 
        Z = (data[4] << 8 | data[5]) >> 4;       // Z 8 bit+4bit 

        // ԊOMtH[}bg:X^[grbg(1)+f[^rbg(4)+Xgbvrbg(1)
        if (Y < YF && Y > 2500) {
            b1(); b0(); b0(); b0(); b1(); b1();     // 0001          
        }

        else if (Y > YB && Y < 1500) {
            b1(); b0(); b0(); b1(); b0(); b1();     // 0010           
        }          

        else if (X > XR && X < 1500) {
            b1(); b0(); b1(); b0(); b0(); b1();     // 0100           
        }

        else if (X < XL && X > 2500) {
            b1(); b1(); b0(); b0(); b0(); b1();     // 1000            
        }
            
        else {
            b1(); b0(); b0(); b0(); b0(); b1();     // 0000            
        }

        __delay_ms(20);           // 20msec
       
    }
}

// ZT[ݒ
void MMA8452_init(void) {

    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(MMA8452_ADRS);        // X[uID(ݗv)w
    i2c_send_byte(0x0E);                // 0x0E:XYZ_DATA_CFG register
    i2c_send_byte(0x00);                // 0x00:Full-scale range=2g, No HPF
    i2c_stop();                         // I2CXgbvRfBVs
    
    i2c_start();                        // I2CX^[gRfBVs
    i2c_send_byte(MMA8452_ADRS);        // X[uID(ݗv)w
    i2c_send_byte(0x2A);                // 0x2A:CTRL_REG1 system control 1 register
    i2c_send_byte(0x01);                // 0x01:Active mode
    i2c_stop();                         // I2CXgbvRfBVs     
}

// Gf[^擾֐
void MMA8452(void) {

    unsigned int i;
      
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(MMA8452_ADRS);        // X[uID(ݗv)w
    i2c_send_byte(0x01);                // f[^ǂݍ݊JnAhX(0x01)w    
    i2c_repeat_start();                 // I2Cs[gX^[gRfBVs
    i2c_send_byte(MMA8452_ADRS + 1);    // X[uID(ǂݍݗv)
    for (i=0; i<6; i++) {               // f[^擾
        if (i==5)
            data[5] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊOACKԂ   
    }

    i2c_stop();                         // I2CXgbvRfBVs     
}

// o[XgM(38kHz/600us)֐
void b1(void) {

    unsigned int i = 23;        // ԊOLED ON/OFF =600us/26us23

// LA[v(1:26us38kHz)  
    while (1)
    {
        RA5 = 1;                 // ԊOLED_ON    
        __delay_us(12);
        RA5 = 0;                 // ԊOLED_OFF    
        __delay_us(7);

        i--;
        if (i==0)
            break;              // JEgAbvŃ[v𔲂    
    }    
}

// uN(600us)֐
void b0(void) {
    
    RA5 = 0;                 // ԊOLED_OFF    
    __delay_us(600);    
  
}

/**
 End of File
*/